<?php
/*
Plugin Name: Animal Captcha
Plugin URI: http://gonzo.teoriza.com/animal-captcha-plugin-para-wordpress
Description: Animal Captcha es un ligero plugin para Wordpress que añade un control captcha en comentarios y registro. Pero en lugar de ser un feo y dificil código alfanumérico el test consiste en decir los nombres de simpaticos animales (nivel de primaria). <a href="http://www.teoriza.com/captcha/example.php"><b>Puedes probar el sistema aquí</b> antes de nada</a>. En resumen: es más seguro, más bonito, más cómodo, más rapido.
Version: 0.9.3
Author: Javier González González (GONZO)
Author URI: http://gonzo.teoriza.com/
Powered by: Blogs Teoriza http://www.Teoriza.com/
License: GPLv2
*/



function ac_print_form_captcha() {
	global $ac_path, $user_ID;
	if ((!isset($user_ID)) || (intval($user_ID) == 0)) {

	if (strpos(WPLANG,'es_') !== false) {
		$question = '&iquest;Qu&eacute; animales ves? &nbsp; (<em>nivel b&aacute;sico, una palabra por animal</em>)'; $animals_try = 'ballena conejo';
	} else { $question = 'What animals do you see? &nbsp; (<em>basic level, in a word for animal</em>)'; $animals_try = 'elephant fly'; }

	echo '<div id="animal-captcha-form">
<label>'.$question.'<br /><input id="focusanimal" type="text" value="'.$animals_try.'" onclick="this.value=\'\';" name="animal-captcha" autocomplete="off" style="width:234px;margin:0 0 5px 0;" /></label><br />
<img src="/wp-content/plugins/animal-captcha/source/animal-captcha.php" border="0" height="120" id="animal-captcha-img" onclick="this.src=\'/wp-content/plugins/animal-captcha/source/animal-captcha.php?\'+Math.random();" style="cursor:pointer;" /><br />
<div><a href="http://gonzo.teoriza.com/animal-captcha" style="color:#666;text-decoration:none;margin:0 0 0 170px;font-size:10px;">Animal Captcha</a></div>
</div>';

	}
}

function ac_captcha_check_comment($comment) {
	global $user_ID, $_POST;
	require('source/animal-captcha-check.php');
	if (((isset($user_ID)) && (intval($user_ID) > 0)) OR (($comment['comment_type'] != '') AND ($comment['comment_type'] != 'comment')) OR (animal_captcha_check($_POST['animal-captcha']))) { 
		return $comment;
	} else {
		wp_die('<strong>Animal Captcha</strong>: captcha error.');
	}
}

function ac_captcha_check_register_net($errors) {
	global $_POST;
	require('source/animal-captcha-check.php');
	if ($_POST['stage'] == 'validate-user-signup') {
		if (!animal_captcha_check($_POST['animal-captcha'])) { 
			$errors->add('captcha_wrong', '<strong>Animal Captcha</strong>: captcha error.');
		}
	}
	return $errors;
}

function ac_captcha_check_register($errors) {
	global $_POST;
	require('source/animal-captcha-check.php');
	if (!animal_captcha_check($_POST['animal-captcha'])) {
		$errors->add('captcha_wrong', '<strong>Animal Captcha</strong>: captcha error.');
	}
	return $errors;
}


// In comments
add_action('comment_form', 'ac_print_form_captcha', 1);
//add_action('comment_form_after_fields', 'ac_print_form_captcha', 1);
add_filter('preprocess_comment', 'ac_captcha_check_comment', 1);

// In signup MU
$ac_ver = explode('.', $wp_version);
if ($ac_ver[0] > 2) {
	add_action('signup_extra_fields', 'ac_print_form_captcha');
	add_filter('wpmu_validate_user_signup', 'ac_captcha_check_register_net');
}

// In registration form
add_action('register_form', 'ac_print_form_captcha', 1);
add_filter('registration_errors', 'ac_captcha_check_register', 1);

?>
